package com.weface.serviceimpl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.weface.common.utils.SnowIdUtil;
import com.weface.dao.PushLogDao;
import com.weface.entity.PushLogEntity;
import com.weface.service.PushLogService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;


@Transactional(rollbackFor = {Exception.class})
@Service("pushLogService")
public class PushLogServiceImpl extends ServiceImpl<PushLogDao, PushLogEntity> implements PushLogService {


    @Override
    public void saveLog(JSONObject data, String phone, Integer messageTemplate) {
        List<PushLogEntity> logList = new ArrayList<>();
        for (Map.Entry<String, Object> stringObjectEntry : data.entrySet()) {
            String key = stringObjectEntry.getKey();
            Object value = stringObjectEntry.getValue();
            if (value != null) {
                JSONObject jsonObject1 = JSONObject.parseObject(value.toString());
                for (Map.Entry<String, Object> objectEntry : jsonObject1.entrySet()) {
                    String key1 = objectEntry.getKey();
                    Object value1 = objectEntry.getValue();
                    PushLogEntity pushLogEntity = new PushLogEntity();
                    pushLogEntity.setId(SnowIdUtil.nextId());
                    pushLogEntity.setTaskId(key);
                    pushLogEntity.setCid(key1);
                    pushLogEntity.setCidStatus(value1.toString());
                    pushLogEntity.setPhone(phone);
                    pushLogEntity.setMessageTemplate(messageTemplate);
                    pushLogEntity.setIsArrive(0);
                    pushLogEntity.setIsValid(1);
                    Date date = new Date();
                    pushLogEntity.setCreateTime(date);
                    pushLogEntity.setUpdateTime(date);
                    logList.add(pushLogEntity);
                }
            }
        }
        if (!CollectionUtils.isEmpty(logList)) {
            this.saveBatch(logList);
        }
    }
}